<script lang="ts">
  import LogoSvg from '$lib/components/svg/LogoSvg.svelte';
  import { links } from '$lib/assets/links';
  import { page } from '$app/stores';
  import Button from '$lib/components/Button.svelte';
  import { getContext, onMount } from 'svelte';
  import { axiosInstance } from '$lib/config';

  const user = getContext('user') as SvelteStore<any>;

  let isOpen = false,
    isPageLoad: boolean = false;

  onMount(() => isPageLoad = true);
</script>

<header class="2xl:px-32 xl:px-24 px-8 py-4 xl:text-2xl md:text-xl space-y-4">
    <section class="flex flex-wrap items-center justify-between gap-6">
        <a href="/">
            <LogoSvg class="h-16 w-auto"/>
        </a>

        {#if isPageLoad && !$user}
            <a href="/login">
                <Button>Войти</Button>
            </a>
        {/if}
        {#if $user}
            <section class="relative">
                <button on:click={() => isOpen = !isOpen} class="flex items-center gap-4">
                    <span>{$user?.lastName} {$user?.firstName}</span>
                    <img src="/image.jpg" alt="" class="object-cover aspect-square w-16 rounded-full">
                </button>
                {#if isOpen}
                    <section class="absolute right-0 mt-2 py-2 w-48 bg-white border rounded-lg shadow-xl z-10">
                        <a
                            href="/profile/{$user?.id}"
                            class="block px-4 py-2 text-gray-800 hover:underline decoration-2 decoration-blue-700"
                        >
                            Профиль
                        </a>
                        <a
                            href="/admin"
                            class="block px-4 py-2 text-gray-800 hover:underline decoration-2 decoration-blue-700"
                        >
                            Админ
                        </a>
                        <button
                            on:click={async () => {
                                await axiosInstance.post('/auth/logout');
                                $user = undefined;
                            }}
                            class="block px-4 py-2 text-gray-800 hover:underline decoration-2 decoration-blue-700"
                        >
                            Выйти
                        </button>
                    </section>
                {/if}
            </section>
        {/if}

    </section>
    <nav class="flex flex-wrap justify-between gap-6">
        {#each links as { name, href }}
            <a
                {href}
                class:active={$page.url.pathname.includes(href)}
                class="uppercase hover:underline decoration-2 decoration-blue-700"
            >
                {name}
            </a>
        {/each}
    </nav>
</header>

<style lang="postcss">
    .active {
        @apply underline;
    }
</style>